import helpers
import difflib

from deepblue_client import DeepBlueClient


class TestScoreMatrixCommand(helpers.TestCase):

  def test_ascore_simple(self):
    epidb = DeepBlueClient(address="localhost", port=31415)
    self.init_base(epidb)

    res = epidb.add_technique("ChIP-seq", "ChIP-sequencing", {}, self.admin_key)
    self.assertSuccess(res)

    broad_peak_format = ",".join([
      "CHROMOSOME",
      "START",
      "END",
      "NAME",
      "SCORE",
      "STRAND",
      "SIGNAL_VALUE",
      "P_VALUE",
      "Q_VALUE",
      ])

    with open("data/wgEncodeBroadHistoneH1hescH3k27me3StdPk.bed", 'r') as f:
      file_data = f.read()
      (res, a_1) = epidb.add_experiment("wgEncodeBroadHistoneH1hescH3k27me3StdPk.bed", "hg19", "H3k4me3", "s1", "ChIPseq", "ENCODE", "wgEncodeBroadHistoneH1hescH3k27me3StdPk.bed from ENCODE",  file_data, broad_peak_format, None, self.admin_key)
      self.assertSuccess(res, a_1)

    with open("data/wgEncodeBroadHistoneH1hescH3k4me3StdPk.bed", 'r') as f:
      file_data = f.read()
      (res, exp) = epidb.add_experiment("wgEncodeBroadHistoneH1hescH3k4me3StdPk.bed", "hg19", "H3k4me3", "s1", "ChIPseq", "ENCODE", "wgEncodeBroadHistoneH1hescH3k4me3StdPk.bed from ENCODE",  file_data, broad_peak_format, None, self.admin_key)
      self.assertSuccess(res, exp)

    # Insert annotation
    cpg_island =  ",".join([
      "CHROMOSOME",
      "START",
      "END",
      "NAME",
      "LENGTH",
      "NUM_CPG",
      "NUM_GC",
      "PER_CPG",
      "PER_CG",
      "OBS_EXP"
      ])

    (s, q_tiling) = epidb.tiling_regions(1000000, "hg19", "chr1", self.admin_key)
    self.assertSuccess(s, q_tiling)

    expected = 'CHROMOSOME\tSTART\tEND\twgEncodeBroadHistoneH1hescH3k27me3StdPk.bed\twgEncodeBroadHistoneH1hescH3k4me3StdPk.bed\nchr1\t0\t1000000\t631.583\t548.931\nchr1\t1000000\t2000000\t479.122\t569.717\nchr1\t2000000\t3000000\t500.223\t487.974\nchr1\t3000000\t4000000\t453.343\t595.174\nchr1\t4000000\t5000000\t557.308\t420.167\nchr1\t5000000\t6000000\t490.75\t462\nchr1\t6000000\t7000000\t547.129\t581.982\nchr1\t7000000\t8000000\t420.364\t532.562\nchr1\t8000000\t9000000\t566.333\t526.619\nchr1\t9000000\t10000000\t658.895\t575.478\nchr1\t10000000\t11000000\t672.9\t562.864\nchr1\t11000000\t12000000\t559.333\t560.484\nchr1\t12000000\t13000000\t489.333\t553.833\nchr1\t13000000\t14000000\t534.5\t572\nchr1\t14000000\t15000000\t543.938\t499\nchr1\t15000000\t16000000\t583.467\t517.895\nchr1\t16000000\t17000000\t611.903\t599.463\nchr1\t17000000\t18000000\t695.355\t574.694\nchr1\t18000000\t19000000\t410.963\t451.615\nchr1\t19000000\t20000000\t677.98\t582.812\nchr1\t20000000\t21000000\t614.013\t530.136\nchr1\t21000000\t22000000\t602.355\t531.435\nchr1\t22000000\t23000000\t440.56\t548.895\nchr1\t23000000\t24000000\t562.298\t541.3\nchr1\t24000000\t25000000\t588.781\t617.296\nchr1\t25000000\t26000000\t536.125\t598.682\nchr1\t26000000\t27000000\t570.833\t549.868\nchr1\t27000000\t28000000\t544.333\t548.217\nchr1\t28000000\t29000000\t653.4\t681.517\nchr1\t29000000\t30000000\t577.154\t524.235\nchr1\t30000000\t31000000\t332.667\t443.333\nchr1\t31000000\t32000000\t540.231\t560.474\nchr1\t32000000\t33000000\t532.909\t640.342\nchr1\t33000000\t34000000\t511.44\t559.463\nchr1\t34000000\t35000000\t387.7\t520\nchr1\t35000000\t36000000\t533.643\t562.294\nchr1\t36000000\t37000000\t613.6\t617.909\nchr1\t37000000\t38000000\t418.4\t506.167\nchr1\t38000000\t39000000\t517.25\t573.308\nchr1\t39000000\t40000000\t555\t570.562\nchr1\t40000000\t41000000\t638.05\t616\nchr1\t41000000\t42000000\t573.58\t507.407\nchr1\t42000000\t43000000\t628.695\t552.5\nchr1\t43000000\t44000000\t406.736\t577.75\nchr1\t44000000\t45000000\t504.908\t563.103\nchr1\t45000000\t46000000\t567.688\t640.192\nchr1\t46000000\t47000000\t475.215\t577.001\nchr1\t47000000\t48000000\t534.834\t485.166\nchr1\t48000000\t49000000\t580.901\t411.684\nchr1\t49000000\t50000000\t275\t465.333\nchr1\t50000000\t51000000\t546.857\t513.444\nchr1\t51000000\t52000000\t690.25\t568\nchr1\t52000000\t53000000\t\t754.909\nchr1\t53000000\t54000000\t557.05\t593.864\nchr1\t54000000\t55000000\t454.762\t532.333\nchr1\t55000000\t56000000\t526.471\t575.583\nchr1\t56000000\t57000000\t332\t392.189\nchr1\t57000000\t58000000\t469.5\t447.049\nchr1\t58000000\t59000000\t672\t402\nchr1\t59000000\t60000000\t664.778\t583.4\nchr1\t60000000\t61000000\t648.2\t644.2\nchr1\t61000000\t62000000\t655.231\t533\nchr1\t62000000\t63000000\t570.5\t599.889\nchr1\t63000000\t64000000\t535.833\t666.444\nchr1\t64000000\t65000000\t570.167\t477.923\nchr1\t65000000\t66000000\t663.786\t568.643\nchr1\t66000000\t67000000\t530.795\t431.932\nchr1\t67000000\t68000000\t626.98\t570.778\nchr1\t68000000\t69000000\t542.6\t578.1\nchr1\t69000000\t70000000\t669.4\t\nchr1\t70000000\t71000000\t869\t801.2\nchr1\t71000000\t72000000\t496\t700.667\nchr1\t72000000\t73000000\t448\t839\nchr1\t73000000\t74000000\t\t\nchr1\t74000000\t75000000\t413\t566\nchr1\t75000000\t76000000\t599.4\t548\nchr1\t76000000\t77000000\t613\t577\nchr1\t77000000\t78000000\t509.4\t697.333\nchr1\t78000000\t79000000\t564\t718.4\nchr1\t79000000\t80000000\t414.667\t537.5\nchr1\t80000000\t81000000\t284\t\nchr1\t81000000\t82000000\t524\t487.5\nchr1\t82000000\t83000000\t423\t528\nchr1\t83000000\t84000000\t\t630.833\nchr1\t84000000\t85000000\t533.889\t660.625\nchr1\t85000000\t86000000\t644.08\t580.529\nchr1\t86000000\t87000000\t622.624\t631.455\nchr1\t87000000\t88000000\t453.5\t597.143\nchr1\t88000000\t89000000\t511\t429\nchr1\t89000000\t90000000\t\t705.5\nchr1\t90000000\t91000000\t542.4\t556.444\nchr1\t91000000\t92000000\t703.062\t559.824\nchr1\t92000000\t93000000\t803.4\t613.4\nchr1\t93000000\t94000000\t493.8\t679.556\nchr1\t94000000\t95000000\t613.737\t591.273\nchr1\t95000000\t96000000\t643.455\t524.333\nchr1\t96000000\t97000000\t769.5\t\nchr1\t97000000\t98000000\t\t450.667\nchr1\t98000000\t99000000\t636.667\t556.8\nchr1\t99000000\t100000000\t744.4\t656.333\nchr1\t100000000\t101000000\t\t808.5\nchr1\t101000000\t102000000\t760.4\t638.167\nchr1\t102000000\t103000000\t441\t572\nchr1\t103000000\t104000000\t360\t670\nchr1\t104000000\t105000000\t477.5\t984\nchr1\t105000000\t106000000\t773.857\t\nchr1\t106000000\t107000000\t411\t\nchr1\t107000000\t108000000\t379\t763\nchr1\t108000000\t109000000\t748.667\t553\nchr1\t109000000\t110000000\t673.4\t622.762\nchr1\t110000000\t111000000\t659.861\t562.767\nchr1\t111000000\t112000000\t656.267\t583.273\nchr1\t112000000\t113000000\t622.667\t560.615\nchr1\t113000000\t114000000\t629.947\t596.474\nchr1\t114000000\t115000000\t312.5\t549.917\nchr1\t115000000\t116000000\t577.143\t654.333\nchr1\t116000000\t117000000\t639.545\t601.273\nchr1\t117000000\t118000000\t447.8\t552.25\nchr1\t118000000\t119000000\t598\t627.4\nchr1\t119000000\t120000000\t479.143\t474.615\nchr1\t120000000\t121000000\t658.364\t598.444\nchr1\t121000000\t122000000\t854.286\t635.867\nchr1\t122000000\t123000000\t\t\nchr1\t123000000\t124000000\t\t\nchr1\t124000000\t125000000\t\t\nchr1\t125000000\t126000000\t\t\nchr1\t126000000\t127000000\t\t\nchr1\t127000000\t128000000\t\t\nchr1\t128000000\t129000000\t\t\nchr1\t129000000\t130000000\t\t\nchr1\t130000000\t131000000\t\t\nchr1\t131000000\t132000000\t\t\nchr1\t132000000\t133000000\t\t\nchr1\t133000000\t134000000\t\t\nchr1\t134000000\t135000000\t\t\nchr1\t135000000\t136000000\t\t\nchr1\t136000000\t137000000\t\t\nchr1\t137000000\t138000000\t\t\nchr1\t138000000\t139000000\t\t\nchr1\t139000000\t140000000\t\t\nchr1\t140000000\t141000000\t\t\nchr1\t141000000\t142000000\t\t\nchr1\t142000000\t143000000\t578\t377\nchr1\t143000000\t144000000\t604.75\t589.833\nchr1\t144000000\t145000000\t588.954\t529.258\nchr1\t145000000\t146000000\t731.935\t626.78\nchr1\t146000000\t147000000\t549.333\t604.231\nchr1\t147000000\t148000000\t552.857\t609.038\nchr1\t148000000\t149000000\t657.5\t572.125\nchr1\t149000000\t150000000\t784\t611.786\nchr1\t150000000\t151000000\t556\t663.1\nchr1\t151000000\t152000000\t539\t652.973\nchr1\t152000000\t153000000\t506\t465.333\nchr1\t153000000\t154000000\t581.385\t625.963\nchr1\t154000000\t155000000\t558.6\t607\nchr1\t155000000\t156000000\t623.739\t698.854\nchr1\t156000000\t157000000\t633.545\t574.277\nchr1\t157000000\t158000000\t482.2\t497.667\nchr1\t158000000\t159000000\t622.917\t545.333\nchr1\t159000000\t160000000\t476.932\t467.412\nchr1\t160000000\t161000000\t501.396\t581.939\nchr1\t161000000\t162000000\t760.318\t698.727\nchr1\t162000000\t163000000\t604.2\t604.917\nchr1\t163000000\t164000000\t554\t496.333\nchr1\t164000000\t165000000\t577\t398.889\nchr1\t165000000\t166000000\t561.429\t618.471\nchr1\t166000000\t167000000\t657.8\t487.625\nchr1\t167000000\t168000000\t503.857\t579.647\nchr1\t168000000\t169000000\t480.5\t611.833\nchr1\t169000000\t170000000\t374\t687.5\nchr1\t170000000\t171000000\t648.333\t565\nchr1\t171000000\t172000000\t426\t630\nchr1\t172000000\t173000000\t576.5\t628.25\nchr1\t173000000\t174000000\t440.372\t697.889\nchr1\t174000000\t175000000\t351.397\t717.5\nchr1\t175000000\t176000000\t415.714\t448.5\nchr1\t176000000\t177000000\t287\t619.25\nchr1\t177000000\t178000000\t487\t633.25\nchr1\t178000000\t179000000\t408.864\t516.929\nchr1\t179000000\t180000000\t518.995\t605.077\nchr1\t180000000\t181000000\t572.636\t578.111\nchr1\t181000000\t182000000\t594.188\t517.371\nchr1\t182000000\t183000000\t584.071\t529.592\nchr1\t183000000\t184000000\t495.138\t595\nchr1\t184000000\t185000000\t605.862\t656.143\nchr1\t185000000\t186000000\t601.2\t622\nchr1\t186000000\t187000000\t418.5\t681.4\nchr1\t187000000\t188000000\t439\t474.5\nchr1\t188000000\t189000000\t\t\nchr1\t189000000\t190000000\t\t\nchr1\t190000000\t191000000\t480.5\t581\nchr1\t191000000\t192000000\t\t\nchr1\t192000000\t193000000\t429\t700\nchr1\t193000000\t194000000\t549\t635.5\nchr1\t194000000\t195000000\t\t\nchr1\t195000000\t196000000\t\t543\nchr1\t196000000\t197000000\t875\t561\nchr1\t197000000\t198000000\t621.333\t524.167\nchr1\t198000000\t199000000\t648.5\t500\nchr1\t199000000\t200000000\t319.907\t485.842\nchr1\t200000000\t201000000\t409.864\t521.017\nchr1\t201000000\t202000000\t516.03\t569.154\nchr1\t202000000\t203000000\t574.6\t575.261\nchr1\t203000000\t204000000\t734.727\t546.188\nchr1\t204000000\t205000000\t486\t522.189\nchr1\t205000000\t206000000\t581.316\t538.711\nchr1\t206000000\t207000000\t559.842\t523.462\nchr1\t207000000\t208000000\t470.4\t657.714\nchr1\t208000000\t209000000\t537.875\t505.333\nchr1\t209000000\t210000000\t545.294\t494.077\nchr1\t210000000\t211000000\t483.167\t586.667\nchr1\t211000000\t212000000\t721.714\t592\nchr1\t212000000\t213000000\t647.294\t674.583\nchr1\t213000000\t214000000\t326.5\t613\nchr1\t214000000\t215000000\t716.053\t489.25\nchr1\t215000000\t216000000\t922\t570.5\nchr1\t216000000\t217000000\t378\t620.75\nchr1\t217000000\t218000000\t595.375\t564\nchr1\t218000000\t219000000\t414\t644.5\nchr1\t219000000\t220000000\t\t537\nchr1\t220000000\t221000000\t557.167\t657.917\nchr1\t221000000\t222000000\t650.429\t516.444\nchr1\t222000000\t223000000\t373\t689.143\nchr1\t223000000\t224000000\t438.059\t514.538\nchr1\t224000000\t225000000\t644.1\t644.692\nchr1\t225000000\t226000000\t437.848\t646.289\nchr1\t226000000\t227000000\t558.235\t583.241\nchr1\t227000000\t228000000\t532.146\t532.5\nchr1\t228000000\t229000000\t633.714\t580.567\nchr1\t229000000\t230000000\t524\t535\nchr1\t230000000\t231000000\t462.833\t562.2\nchr1\t231000000\t232000000\t532.857\t628.778\nchr1\t232000000\t233000000\t527.8\t467.778\nchr1\t233000000\t234000000\t462\t609.667\nchr1\t234000000\t235000000\t591.4\t533.154\nchr1\t235000000\t236000000\t558.5\t624.714\nchr1\t236000000\t237000000\t656.579\t615.6\nchr1\t237000000\t238000000\t795.5\t482\nchr1\t238000000\t239000000\t876\t\nchr1\t239000000\t240000000\t846\t604\nchr1\t240000000\t241000000\t596.75\t561.75\nchr1\t241000000\t242000000\t501.833\t609\nchr1\t242000000\t243000000\t555\t718.75\nchr1\t243000000\t244000000\t396.5\t440\nchr1\t244000000\t245000000\t489.833\t550.722\nchr1\t245000000\t246000000\t478\t554.807\nchr1\t246000000\t247000000\t346.333\t548.667\nchr1\t247000000\t248000000\t497.333\t585.769\nchr1\t248000000\t249000000\t\t831\n'

    (s, req) = epidb.score_matrix({"wgEncodeBroadHistoneH1hescH3k27me3StdPk.bed":"SCORE","wgEncodeBroadHistoneH1hescH3k4me3StdPk.bed":"SCORE"}, "mean",  q_tiling, self.admin_key)

    self.assertSuccess(s, req)
    rs = self.get_regions_request(req)

    expected = 'CHROMOSOME\tSTART\tEND\twgEncodeBroadHistoneH1hescH3k27me3StdPk.bed\twgEncodeBroadHistoneH1hescH3k4me3StdPk.bed\nchr1\t0\t1000000\t18.0000\t29.0000\nchr1\t1000000\t2000000\t37.0000\t60.0000\nchr1\t2000000\t3000000\t14.0000\t39.0000\nchr1\t3000000\t4000000\t23.0000\t23.0000\nchr1\t4000000\t5000000\t13.0000\t6.0000\nchr1\t5000000\t6000000\t20.0000\t5.0000\nchr1\t6000000\t7000000\t31.0000\t57.0000\nchr1\t7000000\t8000000\t11.0000\t16.0000\nchr1\t8000000\t9000000\t6.0000\t21.0000\nchr1\t9000000\t10000000\t19.0000\t23.0000\nchr1\t10000000\t11000000\t20.0000\t22.0000\nchr1\t11000000\t12000000\t21.0000\t31.0000\nchr1\t12000000\t13000000\t6.0000\t12.0000\nchr1\t13000000\t14000000\t2.0000\t3.0000\nchr1\t14000000\t15000000\t16.0000\t5.0000\nchr1\t15000000\t16000000\t15.0000\t19.0000\nchr1\t16000000\t17000000\t31.0000\t41.0000\nchr1\t17000000\t18000000\t31.0000\t36.0000\nchr1\t18000000\t19000000\t23.0000\t13.0000\nchr1\t19000000\t20000000\t25.0000\t16.0000\nchr1\t20000000\t21000000\t27.0000\t22.0000\nchr1\t21000000\t22000000\t31.0000\t23.0000\nchr1\t22000000\t23000000\t25.0000\t19.0000\nchr1\t23000000\t24000000\t20.0000\t20.0000\nchr1\t24000000\t25000000\t9.0000\t27.0000\nchr1\t25000000\t26000000\t8.0000\t22.0000\nchr1\t26000000\t27000000\t24.0000\t38.0000\nchr1\t27000000\t28000000\t12.0000\t46.0000\nchr1\t28000000\t29000000\t5.0000\t29.0000\nchr1\t29000000\t30000000\t13.0000\t17.0000\nchr1\t30000000\t31000000\t3.0000\t3.0000\nchr1\t31000000\t32000000\t13.0000\t19.0000\nchr1\t32000000\t33000000\t22.0000\t38.0000\nchr1\t33000000\t34000000\t25.0000\t41.0000\nchr1\t34000000\t35000000\t10.0000\t3.0000\nchr1\t35000000\t36000000\t14.0000\t17.0000\nchr1\t36000000\t37000000\t15.0000\t33.0000\nchr1\t37000000\t38000000\t20.0000\t18.0000\nchr1\t38000000\t39000000\t24.0000\t39.0000\nchr1\t39000000\t40000000\t18.0000\t32.0000\nchr1\t40000000\t41000000\t20.0000\t30.0000\nchr1\t41000000\t42000000\t27.0000\t27.0000\nchr1\t42000000\t43000000\t12.0000\t12.0000\nchr1\t43000000\t44000000\t12.0000\t32.0000\nchr1\t44000000\t45000000\t20.0000\t29.0000\nchr1\t45000000\t46000000\t16.0000\t26.0000\nchr1\t46000000\t47000000\t8.0000\t33.0000\nchr1\t47000000\t48000000\t16.0000\t27.0000\nchr1\t48000000\t49000000\t31.0000\t8.0000\nchr1\t49000000\t50000000\t1.0000\t3.0000\nchr1\t50000000\t51000000\t7.0000\t9.0000\nchr1\t51000000\t52000000\t8.0000\t11.0000\nchr1\t52000000\t53000000\t\t11.0000\nchr1\t53000000\t54000000\t20.0000\t22.0000\nchr1\t54000000\t55000000\t21.0000\t24.0000\nchr1\t55000000\t56000000\t17.0000\t12.0000\nchr1\t56000000\t57000000\t2.0000\t4.0000\nchr1\t57000000\t58000000\t6.0000\t5.0000\nchr1\t58000000\t59000000\t8.0000\t4.0000\nchr1\t59000000\t60000000\t9.0000\t10.0000\nchr1\t60000000\t61000000\t5.0000\t5.0000\nchr1\t61000000\t62000000\t13.0000\t10.0000\nchr1\t62000000\t63000000\t10.0000\t9.0000\nchr1\t63000000\t64000000\t6.0000\t9.0000\nchr1\t64000000\t65000000\t6.0000\t13.0000\nchr1\t65000000\t66000000\t14.0000\t14.0000\nchr1\t66000000\t67000000\t4.0000\t5.0000\nchr1\t67000000\t68000000\t9.0000\t12.0000\nchr1\t68000000\t69000000\t5.0000\t10.0000\nchr1\t69000000\t70000000\t5.0000\t\nchr1\t70000000\t71000000\t1.0000\t5.0000\nchr1\t71000000\t72000000\t6.0000\t3.0000\nchr1\t72000000\t73000000\t2.0000\t1.0000\nchr1\t73000000\t74000000\t\t\nchr1\t74000000\t75000000\t2.0000\t1.0000\nchr1\t75000000\t76000000\t5.0000\t5.0000\nchr1\t76000000\t77000000\t1.0000\t5.0000\nchr1\t77000000\t78000000\t5.0000\t3.0000\nchr1\t78000000\t79000000\t9.0000\t10.0000\nchr1\t79000000\t80000000\t3.0000\t2.0000\nchr1\t80000000\t81000000\t1.0000\t\nchr1\t81000000\t82000000\t1.0000\t6.0000\nchr1\t82000000\t83000000\t3.0000\t3.0000\nchr1\t83000000\t84000000\t\t6.0000\nchr1\t84000000\t85000000\t9.0000\t8.0000\nchr1\t85000000\t86000000\t11.0000\t17.0000\nchr1\t86000000\t87000000\t5.0000\t11.0000\nchr1\t87000000\t88000000\t4.0000\t7.0000\nchr1\t88000000\t89000000\t1.0000\t2.0000\nchr1\t89000000\t90000000\t\t4.0000\nchr1\t90000000\t91000000\t5.0000\t9.0000\nchr1\t91000000\t92000000\t16.0000\t17.0000\nchr1\t92000000\t93000000\t5.0000\t5.0000\nchr1\t93000000\t94000000\t5.0000\t9.0000\nchr1\t94000000\t95000000\t19.0000\t11.0000\nchr1\t95000000\t96000000\t11.0000\t12.0000\nchr1\t96000000\t97000000\t4.0000\t\nchr1\t97000000\t98000000\t\t3.0000\nchr1\t98000000\t99000000\t6.0000\t5.0000\nchr1\t99000000\t100000000\t5.0000\t3.0000\nchr1\t100000000\t101000000\t\t8.0000\nchr1\t101000000\t102000000\t5.0000\t6.0000\nchr1\t102000000\t103000000\t1.0000\t2.0000\nchr1\t103000000\t104000000\t1.0000\t1.0000\nchr1\t104000000\t105000000\t2.0000\t1.0000\nchr1\t105000000\t106000000\t7.0000\t\nchr1\t106000000\t107000000\t1.0000\t\nchr1\t107000000\t108000000\t1.0000\t2.0000\nchr1\t108000000\t109000000\t3.0000\t3.0000\nchr1\t109000000\t110000000\t10.0000\t21.0000\nchr1\t110000000\t111000000\t36.0000\t30.0000\nchr1\t111000000\t112000000\t15.0000\t11.0000\nchr1\t112000000\t113000000\t6.0000\t13.0000\nchr1\t113000000\t114000000\t19.0000\t19.0000\nchr1\t114000000\t115000000\t8.0000\t12.0000\nchr1\t115000000\t116000000\t7.0000\t9.0000\nchr1\t116000000\t117000000\t11.0000\t11.0000\nchr1\t117000000\t118000000\t5.0000\t12.0000\nchr1\t118000000\t119000000\t5.0000\t5.0000\nchr1\t119000000\t120000000\t7.0000\t13.0000\nchr1\t120000000\t121000000\t11.0000\t9.0000\nchr1\t121000000\t122000000\t14.0000\t15.0000\nchr1\t122000000\t123000000\t\t\nchr1\t123000000\t124000000\t\t\nchr1\t124000000\t125000000\t\t\nchr1\t125000000\t126000000\t\t\nchr1\t126000000\t127000000\t\t\nchr1\t127000000\t128000000\t\t\nchr1\t128000000\t129000000\t\t\nchr1\t129000000\t130000000\t\t\nchr1\t130000000\t131000000\t\t\nchr1\t131000000\t132000000\t\t\nchr1\t132000000\t133000000\t\t\nchr1\t133000000\t134000000\t\t\nchr1\t134000000\t135000000\t\t\nchr1\t135000000\t136000000\t\t\nchr1\t136000000\t137000000\t\t\nchr1\t137000000\t138000000\t\t\nchr1\t138000000\t139000000\t\t\nchr1\t139000000\t140000000\t\t\nchr1\t140000000\t141000000\t\t\nchr1\t141000000\t142000000\t\t\nchr1\t142000000\t143000000\t2.0000\t1.0000\nchr1\t143000000\t144000000\t4.0000\t12.0000\nchr1\t144000000\t145000000\t14.0000\t17.0000\nchr1\t145000000\t146000000\t36.0000\t29.0000\nchr1\t146000000\t147000000\t3.0000\t13.0000\nchr1\t147000000\t148000000\t14.0000\t26.0000\nchr1\t148000000\t149000000\t28.0000\t16.0000\nchr1\t149000000\t150000000\t19.0000\t42.0000\nchr1\t150000000\t151000000\t2.0000\t30.0000\nchr1\t151000000\t152000000\t9.0000\t37.0000\nchr1\t152000000\t153000000\t4.0000\t6.0000\nchr1\t153000000\t154000000\t13.0000\t27.0000\nchr1\t154000000\t155000000\t10.0000\t26.0000\nchr1\t155000000\t156000000\t23.0000\t41.0000\nchr1\t156000000\t157000000\t33.0000\t65.0000\nchr1\t157000000\t158000000\t15.0000\t9.0000\nchr1\t158000000\t159000000\t12.0000\t9.0000\nchr1\t159000000\t160000000\t20.0000\t14.0000\nchr1\t160000000\t161000000\t11.0000\t29.0000\nchr1\t161000000\t162000000\t22.0000\t33.0000\nchr1\t162000000\t163000000\t5.0000\t12.0000\nchr1\t163000000\t164000000\t5.0000\t3.0000\nchr1\t164000000\t165000000\t6.0000\t9.0000\nchr1\t165000000\t166000000\t14.0000\t17.0000\nchr1\t166000000\t167000000\t10.0000\t8.0000\nchr1\t167000000\t168000000\t7.0000\t17.0000\nchr1\t168000000\t169000000\t2.0000\t6.0000\nchr1\t169000000\t170000000\t4.0000\t8.0000\nchr1\t170000000\t171000000\t3.0000\t5.0000\nchr1\t171000000\t172000000\t3.0000\t9.0000\nchr1\t172000000\t173000000\t2.0000\t4.0000\nchr1\t173000000\t174000000\t7.0000\t9.0000\nchr1\t174000000\t175000000\t1.0000\t6.0000\nchr1\t175000000\t176000000\t14.0000\t6.0000\nchr1\t176000000\t177000000\t1.0000\t4.0000\nchr1\t177000000\t178000000\t7.0000\t4.0000\nchr1\t178000000\t179000000\t7.0000\t14.0000\nchr1\t179000000\t180000000\t9.0000\t13.0000\nchr1\t180000000\t181000000\t11.0000\t9.0000\nchr1\t181000000\t182000000\t16.0000\t10.0000\nchr1\t182000000\t183000000\t14.0000\t14.0000\nchr1\t183000000\t184000000\t10.0000\t11.0000\nchr1\t184000000\t185000000\t10.0000\t7.0000\nchr1\t185000000\t186000000\t5.0000\t5.0000\nchr1\t186000000\t187000000\t2.0000\t5.0000\nchr1\t187000000\t188000000\t1.0000\t4.0000\nchr1\t188000000\t189000000\t\t\nchr1\t189000000\t190000000\t\t\nchr1\t190000000\t191000000\t2.0000\t1.0000\nchr1\t191000000\t192000000\t\t\nchr1\t192000000\t193000000\t1.0000\t1.0000\nchr1\t193000000\t194000000\t5.0000\t4.0000\nchr1\t194000000\t195000000\t\t\nchr1\t195000000\t196000000\t\t1.0000\nchr1\t196000000\t197000000\t1.0000\t3.0000\nchr1\t197000000\t198000000\t3.0000\t12.0000\nchr1\t198000000\t199000000\t2.0000\t2.0000\nchr1\t199000000\t200000000\t2.0000\t2.0000\nchr1\t200000000\t201000000\t6.0000\t19.0000\nchr1\t201000000\t202000000\t33.0000\t26.0000\nchr1\t202000000\t203000000\t10.0000\t23.0000\nchr1\t203000000\t204000000\t11.0000\t32.0000\nchr1\t204000000\t205000000\t26.0000\t37.0000\nchr1\t205000000\t206000000\t19.0000\t38.0000\nchr1\t206000000\t207000000\t19.0000\t13.0000\nchr1\t207000000\t208000000\t5.0000\t7.0000\nchr1\t208000000\t209000000\t16.0000\t6.0000\nchr1\t209000000\t210000000\t17.0000\t13.0000\nchr1\t210000000\t211000000\t6.0000\t9.0000\nchr1\t211000000\t212000000\t7.0000\t14.0000\nchr1\t212000000\t213000000\t17.0000\t12.0000\nchr1\t213000000\t214000000\t2.0000\t9.0000\nchr1\t214000000\t215000000\t19.0000\t12.0000\nchr1\t215000000\t216000000\t1.0000\t2.0000\nchr1\t216000000\t217000000\t1.0000\t4.0000\nchr1\t217000000\t218000000\t8.0000\t3.0000\nchr1\t218000000\t219000000\t3.0000\t4.0000\nchr1\t219000000\t220000000\t\t2.0000\nchr1\t220000000\t221000000\t6.0000\t12.0000\nchr1\t221000000\t222000000\t7.0000\t9.0000\nchr1\t222000000\t223000000\t1.0000\t7.0000\nchr1\t223000000\t224000000\t17.0000\t13.0000\nchr1\t224000000\t225000000\t10.0000\t13.0000\nchr1\t225000000\t226000000\t9.0000\t6.0000\nchr1\t226000000\t227000000\t30.0000\t26.0000\nchr1\t227000000\t228000000\t9.0000\t10.0000\nchr1\t228000000\t229000000\t35.0000\t30.0000\nchr1\t229000000\t230000000\t11.0000\t12.0000\nchr1\t230000000\t231000000\t6.0000\t15.0000\nchr1\t231000000\t232000000\t14.0000\t9.0000\nchr1\t232000000\t233000000\t15.0000\t9.0000\nchr1\t233000000\t234000000\t5.0000\t6.0000\nchr1\t234000000\t235000000\t10.0000\t13.0000\nchr1\t235000000\t236000000\t2.0000\t14.0000\nchr1\t236000000\t237000000\t19.0000\t15.0000\nchr1\t237000000\t238000000\t2.0000\t1.0000\nchr1\t238000000\t239000000\t1.0000\t\nchr1\t239000000\t240000000\t1.0000\t1.0000\nchr1\t240000000\t241000000\t4.0000\t4.0000\nchr1\t241000000\t242000000\t6.0000\t4.0000\nchr1\t242000000\t243000000\t1.0000\t4.0000\nchr1\t243000000\t244000000\t2.0000\t5.0000\nchr1\t244000000\t245000000\t6.0000\t16.0000\nchr1\t245000000\t246000000\t7.0000\t8.0000\nchr1\t246000000\t247000000\t3.0000\t6.0000\nchr1\t247000000\t248000000\t6.0000\t13.0000\nchr1\t248000000\t249000000\t\t1.0000\n'

    (s, req) = epidb.score_matrix({"wgEncodeBroadHistoneH1hescH3k27me3StdPk.bed":"SCORE","wgEncodeBroadHistoneH1hescH3k4me3StdPk.bed":"SCORE"}, "count",  q_tiling, self.admin_key)

    self.assertSuccess(s, req)
    rs = self.get_regions_request(req)
    self.assertEquals(expected, rs)

    expected = 'CHROMOSOME\tSTART\tEND\twgEncodeBroadHistoneH1hescH3k27me3StdPk.bed\twgEncodeBroadHistoneH1hescH3k4me3StdPk.bed\nchr1\t0\t1000000\t11368.4873\t15919.0000\nchr1\t1000000\t2000000\t17727.5117\t34183.0000\nchr1\t2000000\t3000000\t7003.1211\t19031.0000\nchr1\t3000000\t4000000\t10426.8789\t13689.0000\nchr1\t4000000\t5000000\t7245.0000\t2521.0000\nchr1\t5000000\t6000000\t9815.0000\t2310.0000\nchr1\t6000000\t7000000\t16961.0000\t33173.0000\nchr1\t7000000\t8000000\t4624.0000\t8521.0000\nchr1\t8000000\t9000000\t3398.0000\t11059.0000\nchr1\t9000000\t10000000\t12519.0000\t13236.0000\nchr1\t10000000\t11000000\t13458.0000\t12383.0000\nchr1\t11000000\t12000000\t11746.0000\t17375.0000\nchr1\t12000000\t13000000\t2936.0000\t6646.0000\nchr1\t13000000\t14000000\t1069.0000\t1716.0000\nchr1\t14000000\t15000000\t8703.0000\t2495.0000\nchr1\t15000000\t16000000\t8752.0000\t9840.0000\nchr1\t16000000\t17000000\t18969.0000\t24578.0000\nchr1\t17000000\t18000000\t21556.0000\t20689.0000\nchr1\t18000000\t19000000\t9452.1406\t5871.0000\nchr1\t19000000\t20000000\t16949.5117\t9325.0000\nchr1\t20000000\t21000000\t16578.3477\t11663.0000\nchr1\t21000000\t22000000\t18673.0000\t12223.0000\nchr1\t22000000\t23000000\t11014.0000\t10429.0000\nchr1\t23000000\t24000000\t11245.9697\t10826.0000\nchr1\t24000000\t25000000\t5299.0303\t16667.0000\nchr1\t25000000\t26000000\t4289.0000\t13171.0000\nchr1\t26000000\t27000000\t13700.0000\t20895.0000\nchr1\t27000000\t28000000\t6532.0000\t25218.0000\nchr1\t28000000\t29000000\t3267.0000\t19764.0000\nchr1\t29000000\t30000000\t7503.0000\t8912.0000\nchr1\t30000000\t31000000\t998.0000\t1330.0000\nchr1\t31000000\t32000000\t7023.0000\t10649.0000\nchr1\t32000000\t33000000\t11724.0000\t24333.0000\nchr1\t33000000\t34000000\t12786.0000\t22938.0000\nchr1\t34000000\t35000000\t3877.0000\t1560.0000\nchr1\t35000000\t36000000\t7471.0000\t9559.0000\nchr1\t36000000\t37000000\t9204.0000\t20391.0000\nchr1\t37000000\t38000000\t8368.0000\t9111.0000\nchr1\t38000000\t39000000\t12414.0000\t22359.0000\nchr1\t39000000\t40000000\t9990.0000\t18258.0000\nchr1\t40000000\t41000000\t12761.0000\t18480.0000\nchr1\t41000000\t42000000\t15486.6641\t13700.0000\nchr1\t42000000\t43000000\t7544.3359\t6630.0000\nchr1\t43000000\t44000000\t4880.8374\t18488.0000\nchr1\t44000000\t45000000\t10098.1631\t16330.0000\nchr1\t45000000\t46000000\t9083.0000\t16645.0000\nchr1\t46000000\t47000000\t3801.7229\t19041.0371\nchr1\t47000000\t48000000\t8557.3457\t13099.4883\nchr1\t48000000\t49000000\t18007.9316\t3293.4751\nchr1\t49000000\t50000000\t275.0000\t1396.0000\nchr1\t50000000\t51000000\t3828.0000\t4621.0000\nchr1\t51000000\t52000000\t5522.0000\t6248.0000\nchr1\t52000000\t53000000\t\t8304.0000\nchr1\t53000000\t54000000\t11141.0000\t13065.0000\nchr1\t54000000\t55000000\t9550.0000\t12776.0000\nchr1\t55000000\t56000000\t8950.0000\t6907.0000\nchr1\t56000000\t57000000\t664.0000\t1568.7563\nchr1\t57000000\t58000000\t2817.0000\t2235.2437\nchr1\t58000000\t59000000\t5376.0000\t1608.0000\nchr1\t59000000\t60000000\t5983.0000\t5834.0000\nchr1\t60000000\t61000000\t3241.0000\t3221.0000\nchr1\t61000000\t62000000\t8518.0000\t5330.0000\nchr1\t62000000\t63000000\t5705.0000\t5399.0000\nchr1\t63000000\t64000000\t3215.0000\t5998.0000\nchr1\t64000000\t65000000\t3421.0000\t6213.0000\nchr1\t65000000\t66000000\t9293.0000\t7961.0000\nchr1\t66000000\t67000000\t2123.1787\t2159.6599\nchr1\t67000000\t68000000\t5642.8213\t6849.3398\nchr1\t68000000\t69000000\t2713.0000\t5781.0000\nchr1\t69000000\t70000000\t3347.0000\t\nchr1\t70000000\t71000000\t869.0000\t4006.0000\nchr1\t71000000\t72000000\t2976.0000\t2102.0000\nchr1\t72000000\t73000000\t896.0000\t839.0000\nchr1\t73000000\t74000000\t\t\nchr1\t74000000\t75000000\t826.0000\t566.0000\nchr1\t75000000\t76000000\t2997.0000\t2740.0000\nchr1\t76000000\t77000000\t613.0000\t2885.0000\nchr1\t77000000\t78000000\t2547.0000\t2092.0000\nchr1\t78000000\t79000000\t5076.0000\t7184.0000\nchr1\t79000000\t80000000\t1244.0000\t1075.0000\nchr1\t80000000\t81000000\t284.0000\t\nchr1\t81000000\t82000000\t524.0000\t2925.0000\nchr1\t82000000\t83000000\t1269.0000\t1584.0000\nchr1\t83000000\t84000000\t\t3785.0000\nchr1\t84000000\t85000000\t4805.0000\t5285.0000\nchr1\t85000000\t86000000\t7084.8794\t9869.0000\nchr1\t86000000\t87000000\t3113.1206\t6946.0000\nchr1\t87000000\t88000000\t1814.0000\t4180.0000\nchr1\t88000000\t89000000\t511.0000\t858.0000\nchr1\t89000000\t90000000\t\t2822.0000\nchr1\t90000000\t91000000\t2712.0000\t5008.0000\nchr1\t91000000\t92000000\t11249.0000\t9517.0000\nchr1\t92000000\t93000000\t4017.0000\t3067.0000\nchr1\t93000000\t94000000\t2469.0000\t6116.0000\nchr1\t94000000\t95000000\t11661.0000\t6504.0000\nchr1\t95000000\t96000000\t7078.0000\t6292.0000\nchr1\t96000000\t97000000\t3078.0000\t\nchr1\t97000000\t98000000\t\t1352.0000\nchr1\t98000000\t99000000\t3820.0000\t2784.0000\nchr1\t99000000\t100000000\t3722.0000\t1969.0000\nchr1\t100000000\t101000000\t\t6468.0000\nchr1\t101000000\t102000000\t3802.0000\t3829.0000\nchr1\t102000000\t103000000\t441.0000\t1144.0000\nchr1\t103000000\t104000000\t360.0000\t670.0000\nchr1\t104000000\t105000000\t955.0000\t984.0000\nchr1\t105000000\t106000000\t5417.0000\t\nchr1\t106000000\t107000000\t411.0000\t\nchr1\t107000000\t108000000\t379.0000\t1526.0000\nchr1\t108000000\t109000000\t2246.0000\t1659.0000\nchr1\t109000000\t110000000\t6734.0000\t13078.0000\nchr1\t110000000\t111000000\t23755.0000\t16883.0000\nchr1\t111000000\t112000000\t9844.0000\t6416.0000\nchr1\t112000000\t113000000\t3736.0000\t7288.0000\nchr1\t113000000\t114000000\t11969.0000\t11333.0000\nchr1\t114000000\t115000000\t2500.0000\t6599.0000\nchr1\t115000000\t116000000\t4040.0000\t5889.0000\nchr1\t116000000\t117000000\t7035.0000\t6614.0000\nchr1\t117000000\t118000000\t2239.0000\t6627.0000\nchr1\t118000000\t119000000\t2990.0000\t3137.0000\nchr1\t119000000\t120000000\t3354.0000\t6170.0000\nchr1\t120000000\t121000000\t7242.0000\t5386.0000\nchr1\t121000000\t122000000\t11960.0000\t9538.0000\nchr1\t122000000\t123000000\t\t\nchr1\t123000000\t124000000\t\t\nchr1\t124000000\t125000000\t\t\nchr1\t125000000\t126000000\t\t\nchr1\t126000000\t127000000\t\t\nchr1\t127000000\t128000000\t\t\nchr1\t128000000\t129000000\t\t\nchr1\t129000000\t130000000\t\t\nchr1\t130000000\t131000000\t\t\nchr1\t131000000\t132000000\t\t\nchr1\t132000000\t133000000\t\t\nchr1\t133000000\t134000000\t\t\nchr1\t134000000\t135000000\t\t\nchr1\t135000000\t136000000\t\t\nchr1\t136000000\t137000000\t\t\nchr1\t137000000\t138000000\t\t\nchr1\t138000000\t139000000\t\t\nchr1\t139000000\t140000000\t\t\nchr1\t140000000\t141000000\t\t\nchr1\t141000000\t142000000\t\t\nchr1\t142000000\t143000000\t1156.0000\t377.0000\nchr1\t143000000\t144000000\t2419.0000\t7078.0000\nchr1\t144000000\t145000000\t8245.3545\t8997.3926\nchr1\t145000000\t146000000\t26349.6465\t18176.6074\nchr1\t146000000\t147000000\t1648.0000\t7855.0000\nchr1\t147000000\t148000000\t7740.0000\t15835.0000\nchr1\t148000000\t149000000\t18410.0000\t9154.0000\nchr1\t149000000\t150000000\t14896.0000\t25695.0000\nchr1\t150000000\t151000000\t1112.0000\t19893.0000\nchr1\t151000000\t152000000\t4851.0000\t24160.0000\nchr1\t152000000\t153000000\t2024.0000\t2792.0000\nchr1\t153000000\t154000000\t7558.0000\t16901.0000\nchr1\t154000000\t155000000\t5586.0000\t15782.0000\nchr1\t155000000\t156000000\t14346.0000\t28653.0000\nchr1\t156000000\t157000000\t20907.0000\t37328.0000\nchr1\t157000000\t158000000\t7233.0000\t4479.0000\nchr1\t158000000\t159000000\t7475.0000\t4908.0000\nchr1\t159000000\t160000000\t9538.6465\t6543.7676\nchr1\t160000000\t161000000\t5515.3535\t16876.2324\nchr1\t161000000\t162000000\t16727.0000\t23058.0000\nchr1\t162000000\t163000000\t3021.0000\t7259.0000\nchr1\t163000000\t164000000\t2770.0000\t1489.0000\nchr1\t164000000\t165000000\t3462.0000\t3590.0000\nchr1\t165000000\t166000000\t7860.0000\t10514.0000\nchr1\t166000000\t167000000\t6578.0000\t3901.0000\nchr1\t167000000\t168000000\t3527.0000\t9854.0000\nchr1\t168000000\t169000000\t961.0000\t3671.0000\nchr1\t169000000\t170000000\t1496.0000\t5500.0000\nchr1\t170000000\t171000000\t1945.0000\t2825.0000\nchr1\t171000000\t172000000\t1278.0000\t5670.0000\nchr1\t172000000\t173000000\t1153.0000\t2513.0000\nchr1\t173000000\t174000000\t3082.6035\t6281.0000\nchr1\t174000000\t175000000\t351.3966\t4305.0000\nchr1\t175000000\t176000000\t5820.0000\t2691.0000\nchr1\t176000000\t177000000\t287.0000\t2477.0000\nchr1\t177000000\t178000000\t3409.0000\t2533.0000\nchr1\t178000000\t179000000\t2862.0479\t7237.0000\nchr1\t179000000\t180000000\t4670.9521\t7866.0000\nchr1\t180000000\t181000000\t6299.0000\t5203.0000\nchr1\t181000000\t182000000\t9507.0000\t5173.7109\nchr1\t182000000\t183000000\t8177.0000\t7414.2891\nchr1\t183000000\t184000000\t4951.3823\t6545.0000\nchr1\t184000000\t185000000\t6058.6177\t4593.0000\nchr1\t185000000\t186000000\t3006.0000\t3110.0000\nchr1\t186000000\t187000000\t837.0000\t3407.0000\nchr1\t187000000\t188000000\t439.0000\t1898.0000\nchr1\t188000000\t189000000\t\t\nchr1\t189000000\t190000000\t\t\nchr1\t190000000\t191000000\t961.0000\t581.0000\nchr1\t191000000\t192000000\t\t\nchr1\t192000000\t193000000\t429.0000\t700.0000\nchr1\t193000000\t194000000\t2745.0000\t2542.0000\nchr1\t194000000\t195000000\t\t\nchr1\t195000000\t196000000\t\t543.0000\nchr1\t196000000\t197000000\t875.0000\t1683.0000\nchr1\t197000000\t198000000\t1864.0000\t6290.0000\nchr1\t198000000\t199000000\t1297.0000\t1000.0000\nchr1\t199000000\t200000000\t639.8142\t971.6837\nchr1\t200000000\t201000000\t2459.1858\t9899.3164\nchr1\t201000000\t202000000\t17029.0000\t14798.0000\nchr1\t202000000\t203000000\t5746.0000\t13231.0000\nchr1\t203000000\t204000000\t8082.0000\t17478.0000\nchr1\t204000000\t205000000\t12636.0000\t19321.0000\nchr1\t205000000\t206000000\t11045.0000\t20471.0000\nchr1\t206000000\t207000000\t10637.0000\t6805.0000\nchr1\t207000000\t208000000\t2352.0000\t4604.0000\nchr1\t208000000\t209000000\t8606.0000\t3032.0000\nchr1\t209000000\t210000000\t9270.0000\t6423.0000\nchr1\t210000000\t211000000\t2899.0000\t5280.0000\nchr1\t211000000\t212000000\t5052.0000\t8288.0000\nchr1\t212000000\t213000000\t11004.0000\t8095.0000\nchr1\t213000000\t214000000\t653.0000\t5517.0000\nchr1\t214000000\t215000000\t13605.0000\t5871.0000\nchr1\t215000000\t216000000\t922.0000\t1141.0000\nchr1\t216000000\t217000000\t378.0000\t2483.0000\nchr1\t217000000\t218000000\t4763.0000\t1692.0000\nchr1\t218000000\t219000000\t1242.0000\t2578.0000\nchr1\t219000000\t220000000\t\t1074.0000\nchr1\t220000000\t221000000\t3343.0000\t7895.0000\nchr1\t221000000\t222000000\t4553.0000\t4648.0000\nchr1\t222000000\t223000000\t373.0000\t4824.0000\nchr1\t223000000\t224000000\t7447.0000\t6689.0000\nchr1\t224000000\t225000000\t6441.0000\t8381.0000\nchr1\t225000000\t226000000\t3940.6348\t3877.7336\nchr1\t226000000\t227000000\t16747.0488\t15164.2666\nchr1\t227000000\t228000000\t4789.3159\t5325.0000\nchr1\t228000000\t229000000\t22180.0000\t17417.0000\nchr1\t229000000\t230000000\t5764.0000\t6420.0000\nchr1\t230000000\t231000000\t2777.0000\t8433.0000\nchr1\t231000000\t232000000\t7460.0000\t5659.0000\nchr1\t232000000\t233000000\t7917.0000\t4210.0000\nchr1\t233000000\t234000000\t2310.0000\t3658.0000\nchr1\t234000000\t235000000\t5914.0000\t6931.0000\nchr1\t235000000\t236000000\t1117.0000\t8746.0000\nchr1\t236000000\t237000000\t12475.0000\t9234.0000\nchr1\t237000000\t238000000\t1591.0000\t482.0000\nchr1\t238000000\t239000000\t876.0000\t\nchr1\t239000000\t240000000\t846.0000\t604.0000\nchr1\t240000000\t241000000\t2387.0000\t2247.0000\nchr1\t241000000\t242000000\t3011.0000\t2436.0000\nchr1\t242000000\t243000000\t555.0000\t2875.0000\nchr1\t243000000\t244000000\t793.0000\t2200.0000\nchr1\t244000000\t245000000\t2939.0000\t8811.5479\nchr1\t245000000\t246000000\t3346.0000\t4438.4521\nchr1\t246000000\t247000000\t1039.0000\t3292.0000\nchr1\t247000000\t248000000\t2984.0000\t7615.0000\nchr1\t248000000\t249000000\t\t831.0000\n'

    (s, req) = epidb.score_matrix({"wgEncodeBroadHistoneH1hescH3k27me3StdPk.bed":"SCORE","wgEncodeBroadHistoneH1hescH3k4me3StdPk.bed":"SCORE"}, "sum",  q_tiling, self.admin_key)

    self.assertSuccess(s, req)
    rs = self.get_regions_request(req)
    self.assertEquals(expected, rs)

  def _test_score_matrix_wrong_experiment(self):
    epidb = DeepBlueClient(address="localhost", port=31415)
    self.init_base(epidb)

    (s, q_tiling) = epidb.tiling_regions(10000000, "hg19", "chr1", self.admin_key)
    self.assertSuccess(s, q_tiling)

    (s, req) = epidb.score_matrix({"wgEncodeBroadHistoneH1hescH3k27me3StdPk.bed":"SCORE"}, "mean",  q_tiling, self.admin_key)
    self.assertFailure(s, req)
    self.assertEquals(req, "Experiment 'wgEncodeBroadHistoneH1hescH3k27me3StdPk.bed' does not exists.")

    sample_id = self.sample_ids[0]

    self.insert_experiment(epidb, "hg19_chr1_1", sample_id)
    (s, req) = epidb.score_matrix({"hg19_chr1_1":"VALUE"}, "mean",  q_tiling, self.admin_key)
    self.assertFailure(s, req)
    self.assertEquals(req, "Experiment 'hg19_chr1_1' does not have the column 'VALUE'.")
